/***************************************************************
 * Name:      wxmunicipios
 * Purpose:   Code for Application Class
 * Author:    seta43 ()
 * Created:   2016-06-06
 * Copyright: seta43 ()
 * License:
 **************************************************************/
// windows -linux 

#include <wx/wx.h>

#include "define.h"

#include <wx/bitmap.h>
#include <wx/intl.h>
#include <wx/image.h> 

char VARI[200];
FILE *fichero;
int Partes[10];
long encontrados;
char mypoblacion[100]; 


#define NOID 1010
#define ID_BUSCAR 1030
#define ID_SIGUIENTE 1031
#define ID_SALIR 1032

class MiAplicacion : public wxApp
{
public:
    virtual bool OnInit();
};

class MiFrame: public wxFrame
{
public:
    MiFrame(wxWindow* parent,wxWindowID id = -1);
    

private:

	
    DECLARE_EVENT_TABLE()

    void OnQuit(wxCommandEvent& event)
		{ 
		  fclose(fichero);
		  Close();
		}
    void OnAbout(wxCommandEvent& event)
            {
                wxString msg;
                msg.Printf(wxT("Programa municipiosWX\nhttp://www.seta43.netau.net/wxseta.html\n%s"),    wxVERSION_STRING);
                wxMessageBox(msg, wxT("SETA43"), wxOK | wxICON_INFORMATION, this);
            }    
    void OnBuscar(wxCommandEvent& event);
    void OnSiguiente(wxCommandEvent& event);
    void mostrar();
    void cuantos();
    int siguiente();

		wxStaticBitmap* StaticBitmap1;
        wxStaticText* StaticText10;
        wxStaticText* StaticText9;
        wxStaticText* Aprovincia;
        wxButton* Abuscar;
        wxTextCtrl* Agrados;
        wxStaticText* Ahabitantes;
        wxStaticText* StaticText13;
        wxStaticText* StaticText2;
        wxButton* Asalir;
        wxStaticText* Apoblacion;
        wxStaticText* StaticText6;
        wxStaticText* Aaltitud;
        wxStaticText* StaticText8;
        wxStaticText* StaticText11;
        wxButton* Asiguiente;
        wxStaticText* StaticText1;
        wxStaticText* StaticText3;
        wxStaticText* Acomunidad;
        wxStaticText* StaticText5;
        wxStaticText* StaticText7;
        wxStaticText* StaticText12;
        wxTextCtrl* Aencontrados;
        wxTextCtrl* Aentrada;
        wxStaticText* StaticText4;
        wxStaticText* Alatitud;
        wxStaticText* Amujeres;
        wxStaticText* Ahombres;
        wxStaticText* Alongitud;        
};


bool MiAplicacion::OnInit()
{
	wxInitAllImageHandlers();
    MiFrame* Frame = new MiFrame(0);
    Frame->Show();
    return true;
}


DECLARE_APP(MiAplicacion)
// Give wxWidgets the means to create a MiAplicacion object
IMPLEMENT_APP(MiAplicacion)

BEGIN_EVENT_TABLE(MiFrame,wxFrame)

    EVT_BUTTON(ID_SALIR, MiFrame::OnQuit)
    EVT_MENU(wxID_ABOUT, MiFrame::OnAbout)
    EVT_MENU(wxID_EXIT, MiFrame::OnQuit)    
    EVT_BUTTON(ID_BUSCAR, MiFrame::OnBuscar)
    EVT_BUTTON(ID_SIGUIENTE, MiFrame::OnSiguiente)

END_EVENT_TABLE();

MiFrame::MiFrame(wxWindow* parent,wxWindowID id)
{
//(*Initialize(MiFrame)
    wxMenuItem* MenuItem2;
    wxMenuItem* MenuItem1;
    wxMenu* Menu1;
    wxMenuBar* MenuBar1;
    wxMenu* Menu2;

    Create(parent, id, _("Municipios"), wxDefaultPosition, wxDefaultSize, wxDEFAULT_FRAME_STYLE, _T("id"));
	this->SetBackgroundColour( wxColour( 255, 255, 176 ) );
	
#if YesWindows
    SetClientSize(wxSize(350,434));
    SetMinSize(wxSize(350,434));
    SetMaxSize(wxSize(350,434));
#else		
	SetClientSize(wxSize(350,434));
    SetMinSize(wxSize(350,434));
    SetMaxSize(wxSize(350,434));
#endif	
	
    Asalir = new wxButton(this,ID_SALIR, _("Salir"), wxPoint(100,360), wxDefaultSize, 0, wxDefaultValidator, _T("ID_BUTTON3"));
	StaticBitmap1 = new wxStaticBitmap(this, NOID, wxBitmap(wxImage(_T("./logo.png"))), wxPoint(1,1), wxDefaultSize, 0, _T("ID_STATICBITMAP1"));
	    
    StaticText1 = new wxStaticText(this, NOID, _("MunicipiosWx"), wxPoint(99,8), wxSize(129,19), 0, _T("ID_STATICTEXT1"));
    StaticText1->SetForegroundColour(wxColour(33,55,128));
    wxFont StaticText1Font(13,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText1->SetFont(StaticText1Font);
    StaticText2 = new wxStaticText(this, NOID, _("http://www.seta43.netau.net/informa.html"), wxPoint(60,32), wxDefaultSize, 0, _T("ID_STATICTEXT2"));
    wxFont StaticText2Font(8,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText2->SetFont(StaticText2Font);
     StaticText3 = new wxStaticText(this, NOID, _("Comunidad"), wxPoint(8,64), wxDefaultSize, 0, _T("ID_STATICTEXT3"));
    StaticText4 = new wxStaticText(this, NOID, _("Provincia"), wxPoint(8,88), wxDefaultSize, 0, _T("ID_STATICTEXT4"));
    StaticText5 = new wxStaticText(this, NOID, _("Población"), wxPoint(8,112), wxDefaultSize, 0, _T("ID_STATICTEXT5"));
    StaticText6 = new wxStaticText(this, NOID, _("Latitud"), wxPoint(8,136), wxDefaultSize, 0, _T("ID_STATICTEXT6"));
    StaticText7 = new wxStaticText(this, NOID, _("Longitud"), wxPoint(144,136), wxDefaultSize, 0, _T("ID_STATICTEXT7"));
    StaticText8 = new wxStaticText(this, NOID, _("GD (grados decimales)"), wxPoint(8,160), wxDefaultSize, 0, _T("ID_STATICTEXT8"));
    wxFont StaticText8Font(8,wxSWISS,wxFONTSTYLE_NORMAL,wxNORMAL,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    StaticText8->SetFont(StaticText8Font);
    StaticText9 = new wxStaticText(this, NOID, _("Altitud"), wxPoint(8,184), wxDefaultSize, 0, _T("ID_STATICTEXT9"));
    StaticText10 = new wxStaticText(this, NOID, _("Habitantes"), wxPoint(8,208), wxDefaultSize, 0, _T("ID_STATICTEXT10"));
    StaticText11 = new wxStaticText(this, NOID, _("Hombres"), wxPoint(8,232), wxDefaultSize, 0, _T("ID_STATICTEXT11"));
    StaticText12 = new wxStaticText(this, NOID, _("Mujeres"), wxPoint(8,256), wxDefaultSize, 0, _T("ID_STATICTEXT12"));
	Agrados = new wxTextCtrl(this, NOID, _("-"), wxPoint(136,152), wxSize(150,24),  wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL1"));
    Aentrada = new wxTextCtrl(this, NOID, _(""), wxPoint(8,292), wxSize(128,24),  0, wxDefaultValidator, _T("ID_TEXTCTRL2"));
    wxFont AentradaFont(13,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Aentrada->SetFont(AentradaFont);
    Abuscar = new wxButton(this, ID_BUSCAR, _("Buscar"), wxPoint(144,292), wxSize(91,24), 0, wxDefaultValidator, _T("ID_BUTTON1"));
    StaticText13 = new wxStaticText(this, NOID, _("Encontrados"), wxPoint(8,330), wxDefaultSize, 0, _T("ID_STATICTEXT13"));
    Asiguiente = new wxButton(this, ID_SIGUIENTE, _("Siguiente"), wxPoint(144,322), wxSize(91,24), 0, wxDefaultValidator, _T("ID_BUTTON2"));
    Aencontrados = new wxTextCtrl(this, NOID, _("-"), wxPoint(104,322), wxSize(32,24),  wxTE_READONLY, wxDefaultValidator, _T("ID_TEXTCTRL3"));
 
    Acomunidad = new wxStaticText(this, NOID, _("-"), wxPoint(104,64), wxSize(128,14), 0, _T("ID_STATICTEXT14"));
    wxFont AcomunidadFont(11,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Acomunidad->SetFont(AcomunidadFont);
    Aprovincia = new wxStaticText(this, NOID, _("-"), wxPoint(104,88), wxDefaultSize, 0, _T("ID_STATICTEXT15"));
    wxFont AprovinciaFont(12,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Aprovincia->SetFont(AprovinciaFont);
    Apoblacion = new wxStaticText(this, NOID, _("-"), wxPoint(104,112), wxDefaultSize, 0, _T("ID_STATICTEXT16"));
    wxFont ApoblacionFont(12,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Apoblacion->SetFont(ApoblacionFont);
    Alatitud = new wxStaticText(this, NOID, _("-"), wxPoint(64,136), wxSize(64,14), 0, _T("ID_STATICTEXT17"));
    wxFont AlatitudFont(10,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Alatitud->SetFont(AlatitudFont);
    Alongitud = new wxStaticText(this, NOID, _("-"), wxPoint(208,136), wxSize(64,14), 0, _T("ID_STATICTEXT18"));
    wxFont AlongitudFont(10,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Alongitud->SetFont(AlongitudFont);
    Aaltitud = new wxStaticText(this, NOID, _("-"), wxPoint(96,184), wxDefaultSize, 0, _T("ID_STATICTEXT19"));
    wxFont AaltitudFont(10,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Aaltitud->SetFont(AaltitudFont);
    Ahabitantes = new wxStaticText(this, NOID, _("-"), wxPoint(96,208), wxDefaultSize, 0, _T("ID_STATICTEXT20"));
    wxFont AhabitantesFont(10,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Ahabitantes->SetFont(AhabitantesFont);
    Ahombres = new wxStaticText(this, NOID, _("-"), wxPoint(96,232), wxDefaultSize, 0, _T("ID_STATICTEXT21"));
    wxFont AhombresFont(10,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Ahombres->SetFont(AhombresFont);
    Amujeres = new wxStaticText(this, NOID, _("-"), wxPoint(96,256), wxDefaultSize, 0, _T("ID_STATICTEXT22"));
    wxFont AmujeresFont(10,wxSWISS,wxFONTSTYLE_NORMAL,wxBOLD,false,_T("Sans"),wxFONTENCODING_DEFAULT);
    Amujeres->SetFont(AmujeresFont);
    
    MenuBar1 = new wxMenuBar();
    Menu1 = new wxMenu();
    MenuItem1 = new wxMenuItem(Menu1, wxID_EXIT, _("Salir\tAlt-F4"), _("Quit the application"), wxITEM_NORMAL);
    Menu1->Append(MenuItem1);
    MenuBar1->Append(Menu1, _("&Menu"));
    Menu2 = new wxMenu();
    MenuItem2 = new wxMenuItem(Menu2, wxID_ABOUT, _("Acerca\tF1"), _("Show info about this application"), wxITEM_NORMAL);
    Menu2->Append(MenuItem2);
    MenuBar1->Append(Menu2, _("Ayuda"));
    SetMenuBar(MenuBar1);

    if(!(fichero=fopen("municipios0.txt","r")))
        {
            sprintf(VARI,"Error abriendo fichero" );
            wxString  msg(VARI, wxConvUTF8);
            wxMessageBox(msg, _("SETA43 ..Municipios"));
        }

}

	void MiFrame::OnBuscar(wxCommandEvent& event)
	{
		wxString textval = Aentrada->GetValue();
		textval=textval.Upper();
		Aentrada->SetValue(textval);

		cuantos();
		siguiente();
		mostrar();
	}
	
    void MiFrame::OnSiguiente(wxCommandEvent& event)
    {
		if(siguiente()) mostrar();
	}
	
    void MiFrame::cuantos()
{
    int z,z1,i;

    fseek(fichero,0,0);
    wxString textval = Aentrada->GetValue();
    strncpy(mypoblacion, (const char*)textval.mb_str(wxConvUTF8), 99);
    encontrados=0;
    while( fgets(VARI,200,fichero))
     {
        z1=strlen(VARI);
        i=0;
        for(z=0;z<z1;z++)
            {
                if(VARI[z]==58) //":"
                    {
                     VARI[z]=0;
                     Partes[i]=z+1;
                     i++;
                     if(i>7)
                        {
                            if(strstr(VARI+Partes[1],mypoblacion))encontrados++;
                            break;
                        }
                    }
            }
     }
     wxString mystring;
     mystring << encontrados;
     Aencontrados->SetValue(mystring);
     fseek(fichero,0,0);
}

void MiFrame::mostrar()
{
 wxString  mystring,mystring1;
 int z;
    mystring= wxString::FromUTF8(VARI);  Acomunidad->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[0]);  Aprovincia->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[1]);  Apoblacion->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[2]);  Alatitud->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[3]);  Alongitud->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[4]);  Aaltitud->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[5]);  Ahabitantes->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[6]);  Ahombres->SetLabel(mystring);
    mystring= wxString::FromUTF8(VARI+Partes[7]);  Amujeres->SetLabel(mystring);

    for(z=Partes[2];z<Partes[3];z++) if(VARI[z]==44) VARI[z]='.';  mystring= wxString::FromUTF8(VARI+Partes[2]);
    for(z=Partes[3];z<Partes[4];z++) if(VARI[z]==44) VARI[z]='.';  mystring1= wxString::FromUTF8(VARI+Partes[3]);
    mystring=mystring +_(",")+mystring1;
    Agrados->SetValue(mystring);

}

	
int MiFrame::siguiente()
    {
		int z,z1,i;

    wxString textval = Aentrada->GetValue();
    strncpy(mypoblacion, (const char*)textval.mb_str(wxConvUTF8), 99);

    while( fgets(VARI,200,fichero))
     {
        z1=strlen(VARI);
        i=0;
        for(z=0;z<z1;z++)
            {
                if(VARI[z]==58) //":"
                    {
                     VARI[z]=0;
                     Partes[i]=z+1;
                     i++;
                     if(i>7) if(strstr(VARI+Partes[1],mypoblacion))return(1);
                    }
            }
     }
    return(0);
	}

